from typing import Generic, TypeVar

from rainbowadn.core import *

__all__ = ('TLRParametres',)

ElementType = TypeVar('ElementType')


class TLRParametres(
    Generic[ElementType]
):
    def __init__(
            self,
            order: int,
            factory: RainbowFactory[ElementType],
    ):
        assert isinstance(order, int)
        assert isinstance(factory, RainbowFactory)
        assert order > 1
        self.order = order
        self.factory = factory
